BitMagic-C++: bm::tmatrix< T, ROWS, COLS > Struct Template Reference

BitMagic-C++

Data Structures | Public Types | Public Member Functions | Static Public Member Functions | Data Fields
bm::tmatrix< T, ROWS, COLS > Struct Template Reference

Mini-matrix for bit transposition purposes. More...

`#include <bmtrans.h>`

Collaboration diagram for bm::tmatrix< T, ROWS, COLS >:
[legend]

## Data Structures
struct | rstat
| Row characteristics for transposed matrix. More...

## Public Types
enum | params { n_rows = ROWS, n_columns = COLS }
typedef T | value_type

## Public Member Functions
const T * | row (unsigned row_idx) const
T * | row (unsigned row_idx)

## Static Public Member Functions
static unsigned | rows ()
static unsigned | cols ()

## Data Fields
T BM_VECT_ALIGN value[ROWS][COLS] | BM_VECT_ALIGN_ATTR

## Detailed Description

### template<typename T, unsigned ROWS, unsigned COLS>
struct bm::tmatrix< T, ROWS, COLS >

Mini-matrix for bit transposition purposes.

Definition at line 40 of file bmtrans.h.

## Member Typedef Documentation

## ◆ value_type

template<typename T , unsigned ROWS, unsigned COLS>

typedef T bm::tmatrix< T, ROWS, COLS >::value_type

Definition at line 42 of file bmtrans.h.

## Member Enumeration Documentation

## ◆ params

template<typename T , unsigned ROWS, unsigned COLS>

enum bm::tmatrix::params

Enumerator
n_rows |
n_columns |

Definition at line 46 of file bmtrans.h.

## Member Function Documentation

## ◆ cols()

template<typename T , unsigned ROWS, unsigned COLS>

static unsigned bm::tmatrix< T, ROWS, COLS >::cols | ( |  | ) |
| inlinestatic

Definition at line 62 of file bmtrans.h.

Referenced by bm::find_effective_columns(), bm::tmatrix_reduce(), and bm::tmatrix_restore().

## ◆ row() [1/2]

template<typename T , unsigned ROWS, unsigned COLS>

T* bm::tmatrix< T, ROWS, COLS >::row | ( | unsigned | row_idx | ) |
| inline

Definition at line 69 of file bmtrans.h.

References BM_ASSERT.

## ◆ row() [2/2]

template<typename T , unsigned ROWS, unsigned COLS>

const T* bm::tmatrix< T, ROWS, COLS >::row | ( | unsigned | row_idx | ) | const
| inline

Definition at line 64 of file bmtrans.h.

References BM_ASSERT.

Referenced by bm::tmatrix_reduce(), and bm::tmatrix_restore().

## ◆ rows()

template<typename T , unsigned ROWS, unsigned COLS>

static unsigned bm::tmatrix< T, ROWS, COLS >::rows | ( |  | ) |
| inlinestatic

Definition at line 61 of file bmtrans.h.

Referenced by bm::find_effective_columns(), bm::tmatrix_reduce(), and bm::tmatrix_restore().

## Field Documentation

## ◆ BM_VECT_ALIGN_ATTR

template<typename T , unsigned ROWS, unsigned COLS>

T BM_VECT_ALIGN value [ROWS][COLS] bm::tmatrix< T, ROWS, COLS >::BM_VECT_ALIGN_ATTR

Definition at line 44 of file bmtrans.h.

The documentation for this struct was generated from the following file:

- bmtrans.h